package cz.nic.tablexia.android.test.instrumentation;

import android.test.ActivityInstrumentationTestCase2;

import com.squareup.spoon.Spoon;

import java.io.File;

import cz.nic.tablexia.android.AndroidLauncher;

/**
 * Created by lhoracek on 5/13/15.
 */
public abstract class AbstractOpenglTest<T extends AndroidLauncher> extends ActivityInstrumentationTestCase2<T> {
    public AbstractOpenglTest(Class<T> activityClass) {
        super(activityClass);
    }

    /**
     * Sleep the thread to wait for animations to complete
     *
     * @param seconds
     */
    protected void sleep(float seconds) {
        try {
            Thread.sleep((int) (seconds * 1000));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    /**
     * Take screenshot using custom OpenGL readPixels buffer method instead of using decorView. Lets the Spoon create the file first and then just overwrites it.
     * Not the best method, but the simplest.
     * @param name
     */
    protected void screenshot(String name) {
        File screenshot = Spoon.screenshot(getActivity(), name);
        getActivity().takeScreenshot(screenshot);
        sleep(3);
    }
}
