package cz.nic.tablexia.android;

import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.os.Bundle;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.backends.android.AndroidApplication;
import com.badlogic.gdx.backends.android.AndroidApplicationConfiguration;

import java.io.File;
import java.io.FileOutputStream;

import cz.nic.tablexia.Tablexia;
import cz.nic.tablexia.debug.BuildConfig;
import cz.nic.tablexia.util.Log;

public class AndroidLauncher extends AndroidApplication {

    private Tablexia tablexia;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        AndroidApplicationConfiguration config = new AndroidApplicationConfiguration();
        initialize(tablexia = new Tablexia(BuildConfig.BUILD_TYPE, getResources().getConfiguration().locale, BuildConfig.VERSION_NAME, savedInstanceState == null), config);
    }

    /**
     * Method supporting screenshots during UI testing the application using OpenGL
     *
     * @param file
     */
    public void takeScreenshot(final File file) {
        tablexia.takeScreenShot(new Tablexia.ScreenshotListener() {
            @Override
            public void screenshotTaken(int[] screen) {
                int width = Gdx.graphics.getWidth();
                int height = Gdx.graphics.getHeight();
                try {
                    for (int i = 0; i < screen.length; ++i) {
                        // The alpha and green channels' positions are preserved while the red and blue are swapped
                        screen[i] = ((screen[i] & 0xff00ff00)) | ((screen[i] & 0x000000ff) << 16) | ((screen[i] & 0x00ff0000) >> 16);
                    }
                    Bitmap sb = Bitmap.createBitmap(screen, width, height, Bitmap.Config.RGB_565);
                    // flip bitmap vertically
                    Matrix matrixMirror = new Matrix();
                    matrixMirror.preScale(1.0f, -1.0f);
                    sb = Bitmap.createBitmap(sb, 0, 0, sb.getWidth(), sb.getHeight(), matrixMirror, false);
                    // overvrite file
                    FileOutputStream fOut = new FileOutputStream(file);
                    sb.compress(Bitmap.CompressFormat.PNG, 100, fOut);
                    sb.recycle();
                    fOut.flush();
                    fOut.close();
                } catch (Exception e) {
                    e.printStackTrace();
                    Log.err(this.getClass().getSimpleName(), e.getMessage());
                }
            }
        });
    }

}
