/*******************************************************************************
 *     Tablexia
 *
 *     Copyright (C) 2013  CZ NIC z.s.p.o. <podpora at nic dot cz>
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

package cz.nic.tablexia.game.trophy;

import cz.nic.tablexia.game.GameDefinition;
import cz.nic.tablexia.game.difficulty.GameDifficulty;

/**
 * Definitions of game trophies
 *
 * @author Matyáš Latner, Vaclav Tarantik
 */
public enum GameTrophyDefinition implements TrophyEnum {

    BANKOVNILOUPEZ_PLAY1(GameDefinition.ROBBERY, GameTrophyTypeDefinition.PLAY_LIMIT_1, "robbery_1_finished", "robbery_1_finished_description", 1), //
    BANKOVNILOUPEZ_PLAY2(GameDefinition.ROBBERY, GameTrophyTypeDefinition.PLAY_LIMIT_2, "robbery_5_finished", "robbery_5_finished_description", 5), //
    BANKOVNILOUPEZ_PLAY3(GameDefinition.ROBBERY, GameTrophyTypeDefinition.PLAY_LIMIT_3, "robbery_10_finished", "robbery_10_finished_description", 10), //
    BANKOVNILOUPEZ_DIFF1(GameDefinition.ROBBERY, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "robbery_1_limit", "robbery_1_limit_description", GameDifficulty.MEDIUM.ordinal()), //
    BANKOVNILOUPEZ_DIFF2(GameDefinition.ROBBERY, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "robbery_2_limit", "robbery_2_limit_description", GameDifficulty.HARD.ordinal()),

    PRONASLEDOVANI_PLAY1(GameDefinition.PURSUIT, GameTrophyTypeDefinition.PLAY_LIMIT_1, "pursuit_1_finished",  "pursuit_1_finished_description", 1), //
    PRONASLEDOVANI_PLAY2(GameDefinition.PURSUIT, GameTrophyTypeDefinition.PLAY_LIMIT_2, "pursuit_5_finished",  "pursuit_5_finished_description", 5), //
    PRONASLEDOVANI_PLAY3(GameDefinition.PURSUIT, GameTrophyTypeDefinition.PLAY_LIMIT_3, "pursuit_10_finished",  "pursuit_10_finished_description", 10), //
    PRONASLEDOVANI_DIFF1(GameDefinition.PURSUIT, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "pursuit_1_limit", "pursuit_1_limit_description", GameDifficulty.MEDIUM.ordinal()), //
    PRONASLEDOVANI_DIFF2(GameDefinition.PURSUIT, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "pursuit_2_limit", "pursuit_2_limit_description", GameDifficulty.HARD.ordinal()),

    UNOS_PLAY1(GameDefinition.KIDNAPPING, GameTrophyTypeDefinition.PLAY_LIMIT_1, "kidnapping_1_finished", "kidnapping_1_finished_description", 1), //
    UNOS_PLAY2(GameDefinition.KIDNAPPING, GameTrophyTypeDefinition.PLAY_LIMIT_2, "kidnapping_5_finished", "kidnapping_5_finished_description", 5), //
    UNOS_PLAY3(GameDefinition.KIDNAPPING, GameTrophyTypeDefinition.PLAY_LIMIT_3, "kidnapping_10_finished", "kidnapping_10_finished_description", 10), //
    UNOS_DIFF1(GameDefinition.KIDNAPPING, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "kidnapping_1_limit",  "kidnapping_1_limit_description", GameDifficulty.MEDIUM.ordinal()), //
    UNOS_DIFF2(GameDefinition.KIDNAPPING, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "kidnapping_2_limit", "kidnapping_2_limit_description", GameDifficulty.HARD.ordinal()),

    NOCNISLEDOVANI_PLAY1(GameDefinition.NIGHT_WATCH, GameTrophyTypeDefinition.PLAY_LIMIT_1, "night_watch_1_finished", "night_watch_1_finished_description", 1), //
    NOCNISLEDOVANI_PLAY2(GameDefinition.NIGHT_WATCH, GameTrophyTypeDefinition.PLAY_LIMIT_2, "night_watch_5_finished", "night_watch_5_finished_description",  5), //
    NOCNISLEDOVANI_PLAY3(GameDefinition.NIGHT_WATCH, GameTrophyTypeDefinition.PLAY_LIMIT_3, "night_watch_10_finished", "night_watch_10_finished_description",10), //
    NOCNISLEDOVANI_DIFF1(GameDefinition.NIGHT_WATCH, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "night_watch_1_limit", "night_watch_1_limit_description",  GameDifficulty.MEDIUM.ordinal()), //
    NOCNISLEDOVANI_DIFF2(GameDefinition.NIGHT_WATCH, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "night_watch_2_limit", "night_watch_2_limit_description",GameDifficulty.HARD.ordinal()),

    STRELNICE_PLAY1(GameDefinition.SHOOTING_RANGE, GameTrophyTypeDefinition.PLAY_LIMIT_1, "shooting_range_1_finished", "shooting_range_1_finished_description", 1), //
    STRELNICE_PLAY2(GameDefinition.SHOOTING_RANGE, GameTrophyTypeDefinition.PLAY_LIMIT_2, "shooting_range_5_finished","shooting_range_5_finished_description", 5), //
    STRELNICE_PLAY3(GameDefinition.SHOOTING_RANGE, GameTrophyTypeDefinition.PLAY_LIMIT_3, "shooting_range_10_finished", "shooting_range_10_finished_description", 10), //
    STRELNICE_DIFF1(GameDefinition.SHOOTING_RANGE, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "shooting_range_1_limit",  "shooting_range_1_limit_description", GameDifficulty.MEDIUM.ordinal()), //
    STRELNICE_DIFF2(GameDefinition.SHOOTING_RANGE, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "shooting_range_2_limit", "shooting_range_2_limit_description", GameDifficulty.HARD.ordinal()),

    POTME_PLAY1(GameDefinition.IN_THE_DARKNESS, GameTrophyTypeDefinition.PLAY_LIMIT_1, "in_the_darkness_1_finished", "in_the_darkness_1_finished_description", 1), //
    POTME_PLAY2(GameDefinition.IN_THE_DARKNESS, GameTrophyTypeDefinition.PLAY_LIMIT_2, "in_the_darkness_5_finished","in_the_darkness_5_finished_description", 5), //
    POTME_PLAY3(GameDefinition.IN_THE_DARKNESS, GameTrophyTypeDefinition.PLAY_LIMIT_3, "in_the_darkness_10_finished", "in_the_darkness_10_finished_description", 10), //
    POTME_DIFF1(GameDefinition.IN_THE_DARKNESS, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_1, "in_the_darkness_1_limit", "in_the_darkness_1_limit_description", GameDifficulty.MEDIUM.ordinal()), //
    POTME_DIFF2(GameDefinition.IN_THE_DARKNESS, GameTrophyTypeDefinition.DIFFICULTY_LIMIT_2, "in_the_darkness_2_limit", "in_the_darkness_2_limit_description", GameDifficulty.HARD.ordinal());


    private GameDefinition          gameDefinition;
    private GameTrophyTypeDefinition trophyTypeDefinition;
    private String                      trophyName;
    private String                      trophyDescription;
    private int                      limit;

    private GameTrophyDefinition(GameDefinition gameDefinition, GameTrophyTypeDefinition trophyTypeDefinition, String trophyName, String trophyDescription, int limit) {

        this.gameDefinition = gameDefinition;
        this.trophyTypeDefinition = trophyTypeDefinition;
        this.trophyName = trophyName;
        this.trophyDescription = trophyDescription;
        this.limit = limit;
    }

    public GameDefinition getGameDefinition() {
        return gameDefinition;
    }

    public GameTrophyTypeDefinition getTrophyTypeDefinition() {
        return trophyTypeDefinition;
    }

    @Override
    public String getTrophyName() {
        return trophyName;
    }

    @Override
    public String getTrophyDescription() {
        return trophyDescription;
    }

    public int getLimit() {
        return limit;
    }

    public static GameTrophyDefinition getTrophyDefinitionByGameAndTrophyType(GameDefinition gameDefinition, GameTrophyTypeDefinition trophyTypeDefinition) {
        for (GameTrophyDefinition trophyDefinition : GameTrophyDefinition.values()) {
            if (trophyDefinition.getGameDefinition().equals(gameDefinition) && (trophyDefinition.getTrophyTypeDefinition() == trophyTypeDefinition)) {
                return trophyDefinition;
            }
        }
        return null;
    }

    public static GameTrophyDefinition getTrophyDefinitionByGameAndLimit(GameDefinition gameDefinition, TrophyGlobalTypeDefinition trophyGlobalTypeDefinition, int limit) {
        for (GameTrophyDefinition trophyDefinition : GameTrophyDefinition.values()) {
            if (trophyDefinition.getGameDefinition().equals(gameDefinition) && (trophyDefinition.getTrophyTypeDefinition().getTrophyGlobalTypeDefinition() == trophyGlobalTypeDefinition) && (trophyDefinition.getLimit() == limit)) {
                return trophyDefinition;
            }
        }
        return null;
    }

}
