package cz.nic.tablexia.graphics;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Pixmap.Format;
import com.badlogic.gdx.graphics.Texture;

/**
 * Texture filled with color.
 * 
 * @author Matyáš Latner
 *
 */
public class ColorTexture extends Texture {

	public ColorTexture(int width, int height, final Color color) {
		super(new Pixmap(width, height, Format.RGB565) {
			
			@Override
			public void setColor (float r, float g, float b, float a) {
				super.setColor(color);
			}
			
		});
	}

}
