package cz.nic.tablexia.screen.gamemenu;

import java.util.ArrayList;
import java.util.List;

import cz.nic.tablexia.game.GameDefinition;

/**
 * Created by lhoracek on 3/11/15.
 */
public final class GameMenuAssets {

    private GameMenuAssets() {
    }


    public static enum GameMenuLayers {
        FORE, MID, BACK, TITLE, STARTBUTTON, STARTBUTTON_PRESSED;
    }

    private static final String GAMEMENU_PATH = "screen/gamemenu/gfx/";

    public static final String OFFICE               = GAMEMENU_PATH + "office.jpg";
    public static final String OFFICE_CLICKMAP      = GAMEMENU_PATH + "clickablemap.png";
    public static final String OFFICE_HELP          = GAMEMENU_PATH + "helplayer.png";
    public static final String OVERLAY              = GAMEMENU_PATH + "overlay.png";
    public static final String VIGNETTE             = GAMEMENU_PATH + "vignetting.png";
    public static final String DESK                 = GAMEMENU_PATH + "desk.png";
    public static final String ENCYCLOPEDIA_PRESSED = GAMEMENU_PATH + "encyclopedia_pressed.png";
    public static final String HALLOFFAME_PRESSED   = GAMEMENU_PATH + "halloffame_pressed.png";
    public static final String STATISTICS_PRESSED   = GAMEMENU_PATH + "statistics_pressed.png";
    public static final String DOOR_PRESSED         = GAMEMENU_PATH + "streetdoor_pressed.png";
    public static final String PROFILE_PRESSED      = GAMEMENU_PATH + "profile_pressed.png";

    public static final String DIFF_BAR          = GAMEMENU_PATH + "difficultyseekbar_background.png";
    public static final String DIFF_THUMB        = GAMEMENU_PATH + "difficultyseekbar_thumb.png";
    public static final String DIFF_THUMB_EASY   = GAMEMENU_PATH + "difficultyseekbar_thumb_easy.png";
    public static final String DIFF_THUMB_HARD   = GAMEMENU_PATH + "difficultyseekbar_thumb_hard.png";
    public static final String DIFF_THUMB_MEDIUM = GAMEMENU_PATH + "difficultyseekbar_thumb_medium.png";

    public static final String GAME_ROBBERY_BASE         = "bankovniloupez";
    public static final String GAME_PURSUIT_BASE         = "pronasledovani";
    public static final String GAME_KIDNAPPING_BASE      = "unos";
    public static final String GAME_SHOOTING_RANGE_BASE  = "strelnice";
    public static final String GAME_NIGHT_WATCH_BASE     = "nocnisledovani";
    public static final String GAME_IN_THE_DARKNESS_BASE = "potme";

    public static final String TEXT_PATH = "text/gamemenu";

    public static List<String> textures = new ArrayList<String>();

    static {
        textures.add(OFFICE);
        textures.add(OFFICE_CLICKMAP);
        textures.add(DESK);
        textures.add(OFFICE_HELP);
        textures.add(VIGNETTE);
        textures.add(OVERLAY);

        textures.add(DIFF_BAR);
        textures.add(DIFF_THUMB);
        textures.add(DIFF_THUMB_EASY);
        textures.add(DIFF_THUMB_HARD);
        textures.add(DIFF_THUMB_MEDIUM);

        textures.add(ENCYCLOPEDIA_PRESSED);
        textures.add(HALLOFFAME_PRESSED);
        textures.add(STATISTICS_PRESSED);
        textures.add(DOOR_PRESSED);
        textures.add(PROFILE_PRESSED);

        String baseGameAsset = "MENU_GAME_";
        for (GameDefinition gd : GameDefinition.getActiveGames()) {
            for (GameMenuLayers gml : GameMenuLayers.values()) {
                textures.add(getResourcePath(gd, gml));
            }
        }
    }

    public static String getResourcePath(GameDefinition game, GameMenuLayers layer) {
        try {
            return GAMEMENU_PATH + (GameMenuAssets.class.getField("GAME_" + game.name() + "_BASE").get(null)) + "_" + layer.name().toLowerCase() + ".png";
        } catch (Exception e) {
            throw new IllegalArgumentException("Error generating path for " + game.name() + " " + layer.name());
        }
    }
}