package cz.nic.tablexia.screen.statistics;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.ui.Container;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Label.LabelStyle;
import com.badlogic.gdx.scenes.scene2d.utils.TextureRegionDrawable;

import java.util.List;

import cz.nic.tablexia.TablexiaSettings;
import cz.nic.tablexia.loader.application.ApplicationTextureManager;
import cz.nic.tablexia.screen.AbstractTablexiaScreen;

public class StatisticsScreen extends AbstractTablexiaScreen<Void> {

    private Container<Label> 	backgroundLayout;

	@Override
	protected void prepareScreenTextureAssetNames(List<String> textureFileNames) {
		textureFileNames.add(ApplicationTextureManager.UniversalAssets.BACKGROUND_WOODEN);
	}
	
	@Override
	protected void screenLoaded() {
		backgroundLayout = new Container<Label>();
		backgroundLayout.setBackground(new TextureRegionDrawable(new TextureRegion(getTexture(ApplicationTextureManager.UniversalAssets.BACKGROUND_WOODEN))));
		
		Label label = new Label(getClass().getSimpleName(), new LabelStyle(getDefaultRegularFont(), Color.WHITE));
		label.setPosition(getStage().getWidth() / 2, getStage().getHeight() / 2);
		backgroundLayout.setActor(label);
		
		backgroundLayout.setDebug(TablexiaSettings.getInstance().isShowBoundingBoxes());
		getStage().addActor(backgroundLayout);
	}
	
	@Override
	public void screenResized(int width, int height) {		
		backgroundLayout.setBounds(0, 0, getStage().getWidth(), getStage().getHeight());
	}

}