package cz.nic.tablexia.screen.viewport;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import java.util.List;

import cz.nic.tablexia.loader.TablexiaAssetManager;
import cz.nic.tablexia.screen.AbstractTablexiaScreen;

public class FullscreenImageDebugScreen extends AbstractTablexiaScreen<Void> {

    private static final String LOADER_BACKGROUND = "gfx/screen_loader_background.jpg";
    private static final String LOADER_SMALL_HAND = "gfx/screen_loader_smallhand.png";
    private static final String LOADER_BIG_HAND = "gfx/screen_loader_bighand.png";

    public FullscreenImageDebugScreen() {
        super(false, false, TablexiaAssetManager.StorageType.INTERNAL);
    }

    @Override
    protected void prepareScreenTextureAssetNames(List<String> textureFileNames) {
        textureFileNames.add(LOADER_BACKGROUND);
        textureFileNames.add(LOADER_SMALL_HAND);
        textureFileNames.add(LOADER_BIG_HAND);
    }

    @Override
    protected void screenLoaded() {
        Image background = new Image(getTexture(LOADER_BACKGROUND));
        background.setPosition(0, 0);
        background.setSize(getStage().getWidth(), getStage().getHeight());
        getStage().addActor(background);

        Image smallhand = new Image(getTexture(LOADER_SMALL_HAND));
        smallhand.setPosition(getStage().getWidth() * 0.22f, getStage().getHeight() * 0.64f);
        smallhand.setSize(getStage().getWidth() * 0.01f, getStage().getHeight() * 0.06f);
        getStage().addActor(smallhand);
        smallhand.setOrigin(smallhand.getWidth() / 2, 0);
        smallhand.addAction(Actions.forever(Actions.rotateBy(-360, 6)));

        Image bighand = new Image(getTexture(LOADER_BIG_HAND));
        bighand.setPosition(getStage().getWidth() * 0.22f, getStage().getHeight() * 0.64f);
        bighand.setSize(getStage().getWidth() * 0.01f, getStage().getHeight() * 0.06f);
        getStage().addActor(bighand);
        bighand.setOrigin(bighand.getWidth() / 2, 0);
        bighand.addAction(Actions.forever(Actions.rotateBy(-360, 0.5f)));
    }

    @Override
    public Texture getTexture(String textureName) {
        Texture t = super.getTexture(textureName);
        t.setFilter(Texture.TextureFilter.Linear, Texture.TextureFilter.Linear);
        return t;
    }
}
