package cz.nic.tablexia.util.ui.dialog;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Table;

import cz.nic.tablexia.util.ui.dialog.text.DialogTextContent;

/**
 * Created by Václav Tarantík on 19.3.15.
 */
public class ImageDialog extends TextDialog {
    private Table imageTable;
    private Texture[] textures;

    public ImageDialog(float x, float y,float width, float height,BackGroundType backGroundType,  DialogTextContent dialogTextContent,Texture... textures) {
        super(x,y,width,height, backGroundType,dialogTextContent);
        this.textures = textures;
        imageTable = new Table();
    }

    protected void prepareContent(){
        super.prepareContent();
        getContentTable().row();
        prepareImages();
    }

    private void prepareImages(){

        for(Texture texture:textures){
            addImage(texture);
        }
        getContentTable().add(imageTable).width(getWidth() / 2).height(getHeight()/2);
    }

    protected void addImage(Texture texture){
        Image image = new Image(texture);
        imageTable.add(image).padBottom(20f);
        imageTable.row();
    }

}
